﻿
Imports System.Collections.ObjectModel
Imports Newtonsoft.Json

Public Class MainViewModel
    Inherits ViewModel.Instrastructure.ViewModelBase

    Private StopWatch As New Stopwatch()

    Public Sub New()
        Output = "Benchmark wird durchgeführt..." & Environment.NewLine

        StopWatch.Start()
        InhaltGesamt = JsonConvert.DeserializeObject(Of ObservableCollection(Of MP3FileInfoVM))(System.IO.File.ReadAllText(System.IO.Directory.GetCurrentDirectory & "\musicdata.dtb"))
        StopWatch.Stop()

        Output += "Anzahl der Datensätze: " & InhaltGesamt.Count.ToString & Environment.NewLine
        Output += "Deserialisieren: " & StopWatch.ElapsedMilliseconds & " Millisekunden" & Environment.NewLine

        StopWatch.Reset()
        StopWatch.Start()
        'Dim ZuSpeicherndeDTB As String = JsonConvert.SerializeObject(InhaltGesamt)

        Dim ser = New JsonSerializer()
        Using sw = New System.IO.StreamWriter(System.IO.Directory.GetCurrentDirectory & "\musicdata.dtb") ', jrd = New JsonTextWriter(sw)
            ser.Serialize(sw, InhaltGesamt)
        End Using

        StopWatch.Stop()

        Output += "Serialisieren: " & StopWatch.ElapsedMilliseconds & " Millisekunden" & Environment.NewLine


    End Sub

    Private _Output As String
    Public Property Output As String
        Get
            Return _Output
        End Get
        Set(value As String)
            _Output = value
            RaisePropertyChanged()
        End Set
    End Property

    Private _InhaltGesamt As ObservableCollection(Of ViewModel.MP3FileInfoVM)
    Public Property InhaltGesamt As ObservableCollection(Of ViewModel.MP3FileInfoVM)
        Get
            Return _InhaltGesamt
        End Get
        Set(value As ObservableCollection(Of ViewModel.MP3FileInfoVM))
            _InhaltGesamt = value
            RaisePropertyChanged()
        End Set
    End Property
End Class
